%             heun2.m
% Heun method (explicit 2nd order RK method)
% f: vectorfield
% x0: initial conditions
% t0, tf: time span
% N: divisions of the time interval (timestep h=(tf-t0)/N)
function [t x] = heun2(f,t0,tf,x0,N)
h = (tf-t0)/N;
t=t0:h:tf; x=x0';y=x0;
for i=1:N;
t1 = t(i) + 2*h/3; 
  K1 = f(t,y);
  K2 = f(t1,y+2*h*K1/3);
  y = y + (K1 + 3*K2)*h/4;
  x = [x ; y' ];
end

