%             rk4.m
% 4-stage 4th-order estandard RK method
% f: vectorfield
% x0: initial conditions
% t0, tf: time span
% N: divisions of the time interval (timestep h=(tf-t0)/N)
function [t x] = rk4(f,t0,tf,x0,N)
h = (tf-t0)/N;
t=t0:h:tf; x=x0';y=x0;
for i=1:N;
  t1 = t(i) + h/2; t2 = t(i) + h/2; t3 = t(i) + h;
  K1 = f(t,y);
  K2 = f(t1,y+h*K1/2);
  K3 = f(t2,y+h*K2/2);
  K4 = f(t3,y+h*K3);
  y = y + (K1 + 2*K2 + 2*K3 + K4)*h/6;
  x = [x ; y' ];
end

